{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Jobrotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationTeam:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
        },
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            t.stores.viewoptions=new mj.store({
                data:[{id:'total',code:"{{ 'ReportOee.view_total'|trans }}"}
                    ,{id:'list',code:"{{ 'ReportOee.view_list'|trans }}"}
                    //,{id:'separatepage',code:"{{ 'ReportOee.view_separatepage'|trans }}"}
                ]
            });
            t.checks = {};
	        t.stationData = {};
            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 170,
                        height : 260
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 300,
                        height : 260,
                        style : 'position:absolute;top:0px;left:210px;',
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'ReportOee.start'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'start',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'ReportOee.finish'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'finish',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ReportOee.jobrotation'|trans }}",
                                placeHolder: "{{ 'ReportOee.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation',
                                labelWidth : '110px',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                notEmpty: true,
                                grid: 's12 m6',
                                width: 170,
                                store: t.extras.job_rotations
                            }),
                            new mj.form.combo({
                                title: "{{ 'ReportOee.jobrotationteam'|trans }}",
                                placeHolder: "{{ 'ReportOee.jobrotationteam_placeholder'|trans }}",
                                dataIndex: 'jobrotationteam',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                width: 170,
                                store: t.extras.job_rotation_teams
                            }),
                            new mj.form.numberField({
                                title: "{{ 'ReportOee.shortlost'|trans }}",
                                dataIndex: 'shortlost',
                                maxLength: 2,
                                notEmpty: true,
                                labelWidth : '110px',
                                grid: 's12 m6',
                                width:20
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'ReportOee.isdetail'|trans }}",
                                dataIndex: 'isdetail',
                                itemStyle: 'padding:0 35px 0 0;float:left;',
                                labelWidth : '110px',
                                grid: 'none'
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'ReportOee.islostdetail'|trans }}",
                                dataIndex: 'islostdetail',
                                itemStyle: 'padding:0 35px 0 0;float:left;',
                                labelWidth : '110px',
                                grid: 'none'
                            }),
                            new mj.form.combo({
                                title: "{{ 'ReportOee.viewoptions'|trans }}",
                                placeHolder: "{{ 'ReportOee.viewoptions_placeholder'|trans }}",
                                dataIndex: 'viewoption',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                sameValueDisplay:false,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                width: 170,
                                store: t.stores.viewoptions
                            })
                        ]
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'ReportOee.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'ReportOee.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });

            t.buttons.export = t.forms.main.addButton({
                alt: "{{ 'ReportOee.calculate'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-compile',
                scope: t,
                handler: t._onExportButtonClick
			});
            var _customer=(window.location.href.indexOf('1.40')>-1||window.location.href.indexOf('10.10.0.10')-1)?'sahince':'other';
            t.kisadurus=t.forms.main.items[8];
            t.kisadurus.setValue((_customer=='sahince'?0:10));
            t.len=t.forms.main.items.length;
            
            for(var i = 0,l = t.extras.clients.length;i<l;i++){
                if(t.forms.main.items.getIndex('id','client_' + t.extras.clients[i].code) === -1){
                    t.forms.main.add(
                        new mj.form.checkBox({
                            title : t.extras.clients[i].code,
                            id : 'client_' + t.extras.clients[i].code,
                            labelWidth : '130px',
                            labelPos : 'right',
                            dataIndex : 'client'/*,
                            checked : st.data[i].checked*/
                        }),'f1'
                    );
                }
            }
            t.checks.client = t.forms.main.items[0].items;
            t.tabPanels.main.setActive(0);
        },
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[0].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        editSelectedRecord: function(){
            return;
        },
        _onExportButtonClick:function(a){
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            if (f.modulename && typeof Routing !== 'undefined') {
                t.waitMaskShow();
                var routeName = f.modulename + '-calculate-web';
                var route = Routing.getRoute(routeName);
                var url = Routing.generate(routeName);
                var formData = f.getValue();
                var data = {day:formData.start};
                data.menuId = t.id;
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify(data),
                        dataType: 'json',
                        processData: false,
                        success: function(data, textStatus, xhr) {
                            if(textStatus==='success'){
                                t.waitMaskHide();
                            }
                        },
                        error: function(xhr, textStatus, errorThrown) {
                            t.waitMaskHide();
                            if(xhr.responseJSON&&xhr.responseJSON.message){
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: xhr.responseJSON.message,
                                    type: "error",
                                    html: true
                                });
                            }
                        },
                        complete: function(jqXHR, textStatus) {
                            t.waitMaskHide();
                        }
                    });
                }
            }
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var clients="";
                    var flag=false;
                    for(var i = 0 , l = t.checks.client.length;i<l;i++){
                        if(t.checks.client[i].checked){
                            flag=true;
                            id = t.checks.client[i].id.replace('client_','');
                            clients=(clients==""?id:clients+","+id);
                        }
                    }
                    if(flag){
                        t.waitMaskShow();
                        var id = f.getValue('id').id;
                        var versionField = f.getField('version');
                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                        var mode = id ? 'update' : 'add';
                        var routeName = f.modulename + '-' + mode;
                        var route = Routing.getRoute(routeName);
                        var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                            'pg': t.grids.main.pbar.current,
                            'lm': t.grids.main.pbar.limit
                        } : {'pg':1,'lm':25};
                        var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                            'id': id,
                            'v': version
                        }) : pagerParams);
                        var data = f.getValue();
                        data.clients=clients;
                        data.menuId = t.id;
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                            t.waitMaskShow();
                            t._event='save';
                            $.ajax({
                                url: url,
                                method: "POST",
                                headers: { 
                                    "Content-Type": "application/json",
                                    "X-HTTP-Method-Override": route.methods[0] 
                                },
                                data: JSON.stringify(data),
                                dataType: 'binary',
		                        processData: false,
                                success: function(data, textStatus, xhr) {
                                    //t.activateTabGrid();
                                    if(textStatus==='success'){
                                        var filename = "";
                                        var disposition = xhr.getResponseHeader('Content-Disposition');
                                        if (disposition && disposition.indexOf('attachment') !== -1) {
                                            var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                            var matches = filenameRegex.exec(disposition);
                                            if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                                        }
                                        var type = xhr.getResponseHeader('Content-Type');
                                        var blob = typeof File === 'function'
                                            ? new File([data], filename, { type: type })
                                            : new Blob([data], { type: type });
                                        if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                            // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                            window.navigator.msSaveBlob(blob, filename);
                                            t.waitMaskHide();
                                        } else {
                                            var URL = window.URL || window.webkitURL;
                                            var downloadUrl = URL.createObjectURL(blob);
                                            if (filename) {
                                                // use HTML5 a[download] attribute to specify filename
                                                var a = document.createElement("a");
                                                // safari doesn't support this yet
                                                if (typeof a.download === 'undefined') {
                                                    window.location = downloadUrl;
                                                    t.waitMaskHide();
                                                } else {
                                                    a.href = downloadUrl;
                                                    a.download = filename;
                                                    document.body.appendChild(a);
                                                    a.click();
                                                    t.waitMaskHide();
                                                }
                                            } else {
                                                window.location = downloadUrl;
                                                t.waitMaskHide();
                                            }

                                            setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                                        }
                                    }
                                },
                                error: function(xhr, textStatus, errorThrown) {
                                    t.waitMaskHide();
                                    if(xhr.responseJSON&&xhr.responseJSON.message){
                                        mj.message({
                                            title: mj.lng.glb.error,
                                            msg: xhr.responseJSON.message,
                                            type: "error",
                                            html: true
                                        });
                                    }
                                },
                                complete: function(jqXHR, textStatus) {
                                    t.waitMaskHide();
                                }
                            });
                        }
                    }else{
                        t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
